/*-----------------------------------------------------------------------------
  Module header file for: at module
-----------------------------------------------------------------------------*/

#ifndef atddr_H
#define atddr_H

#ifndef UTIL_H
#include "util.h"
#endif

#ifndef at_TYPEDEF_H
#include "attypedef.h"
#endif

#ifndef dbddr_H
#include "dbddr.h"
#endif

/*-----------------------------------------------------------------------------
    Typedefs, constants, and enums here.
-----------------------------------------------------------------------------*/
typedef struct _atMport *atMport;
typedef struct _atContext *atContext;
typedef struct _atAttr *atAttr;
typedef struct _atPort *atPort;
typedef struct _atRoot *atRoot;
typedef struct _atDevice *atDevice;
typedef struct _atPin *atPin;

/*----------------------------------------------------------------------------
  Mport methods.
----------------------------------------------------------------------------*/
#define atMportNull ((atMport)(NULL))
extern atMport atMportAlloc(dbMport super);
#define _atMportNextFree(Mport) (*(atMport *)(void *)(Mport))
extern void atMportFree(atMport Mport);
extern void atMportDestroy(atMport Mport);
#define atMportSub(baseClass) (dbMportNull==(baseClass)?atMportNull:(atMport)((long)dbMportGetfirstExtension(baseClass) - _utOffset(struct _atMport, _extension)))
#define atMportSuper(Mport) ((Mport)->_super)
#define atMportExtended(Mport) (dbMportGetfirstExtension(Mport) != utExtensionNull &&\
dbMportGetfirstExtension(Mport)->functionTable->className == \
 atMportClassName)
#define atMportGetCurrentSum(Mport) ((Mport)->CurrentSum)
#define atMportSetCurrentSum(_Mport, value) ((_Mport)->CurrentSum = (value))
#define atMportGetSum(Mport) ((Mport)->Sum)
#define atMportSetSum(_Mport, value) ((_Mport)->Sum = (value))

/*----------------------------------------------------------------------------
  Context methods.
----------------------------------------------------------------------------*/
#define atContextNull ((atContext)(NULL))
extern atContext atContextAlloc(void);
#define _atContextNextFree(Context) (*(atContext *)(void *)(Context))
extern void atContextFree(atContext Context);
#define atContextGetDestructorHook() (atContextDestructorHook)
#define atContextSetDestructorHook(func) (atContextDestructorHook = (func))
extern void atContextDestroy(atContext Context);
extern void atContextInsertAttr(atContext Context, atAttr _Attr);
extern void atContextRemoveAttr(atContext Context, atAttr _Attr);
extern void atContextAppendAttr(atContext Context, atAttr _Attr);
#define atContextFindAttr(Context, name) (atAttr)utqEntryHtblSym(&(Context)->Attrs, name)
#define atContextGetnumAttrs(Context) ((Context)->Attrs.count)
#define atContextGetAttrs(Context) (&(Context)->Attrs)
#define atContextGetfirstAttr(Context) ((atAttr)(utfHtblEntry(atContextGetAttrs(Context))))
#define atContextGetlastAttr(Context) ((atAttr)(utlHtblEntry(atContextGetAttrs(Context))))
#define atForeachContextAttr(Context, _Attr) for(_Attr = atContextGetfirstAttr(Context); \
_Attr != atAttrNull; _Attr = atAttrGetnextContextAttr(_Attr))
#define atEndForeachContextAttr
#define atSafeForeachContextAttr(Context, _Attr) {\
    atAttr _nextAttr;\
    for(_Attr = atContextGetfirstAttr(Context); \
        _Attr != atAttrNull; _Attr = _nextAttr) {\
        _nextAttr = atAttrGetnextContextAttr(_Attr);
#define atEndSafeForeachContextAttr }}

/*----------------------------------------------------------------------------
  Attr methods.
----------------------------------------------------------------------------*/
#define atAttrNull ((atAttr)(NULL))
extern atAttr _atAttrAlloc(void);
#define _atAttrNextFree(Attr) (*(atAttr *)(void *)(Attr))
#define atAttrAlloc() (_atFirstFreeAttr == atAttrNull? _atAttrAlloc() : (\
    _atTempAttr = _atFirstFreeAttr,\
    _atFirstFreeAttr = _atAttrNextFree(_atFirstFreeAttr),\
    memset((void *)_atTempAttr, 0, sizeof(struct _atAttr)),\
    _atTempAttr))
#define atAttrFree(Attr) (_atAttrNextFree(Attr) = _atFirstFreeAttr, _atFirstFreeAttr = (Attr))
#define atAttrGetDestructorHook() (atAttrDestructorHook)
#define atAttrSetDestructorHook(func) (atAttrDestructorHook = (func))
extern void atAttrDestroy(atAttr Attr);
#define atAttrGetValue(Attr) ((Attr)->Value)
#define atAttrSetValue(_Attr, value) ((_Attr)->Value = (value))
#define atAttrGetContext(_Attr) ((_Attr)->Context)
#define atAttrSetContext(_Attr, value) ((_Attr)->Context = (value))
#define atAttrGetSym(Attr) ((Attr)->h.Sym)
#define atAttrSetSym(Attr, _sym) ((Attr)->h.Sym = (_sym))
#define atAttrGetnextContextAttr(Attr) ((atAttr)((Attr)->h.nEntry))

/*----------------------------------------------------------------------------
  Port methods.
----------------------------------------------------------------------------*/
#define atPortNull ((atPort)(NULL))
extern atPort atPortAlloc(dbPort super);
#define _atPortNextFree(Port) (*(atPort *)(void *)(Port))
extern void atPortFree(atPort Port);
extern void atPortDestroy(atPort Port);
#define atPortSub(baseClass) (dbPortNull==(baseClass)?atPortNull:(atPort)((long)dbPortGetfirstExtension(baseClass) - _utOffset(struct _atPort, _extension)))
#define atPortSuper(Port) ((Port)->_super)
#define atPortExtended(Port) (dbPortGetfirstExtension(Port) != utExtensionNull &&\
dbPortGetfirstExtension(Port)->functionTable->className == \
 atPortClassName)
#define atPortGetSum(Port) ((Port)->Sum)
#define atPortSetSum(_Port, value) ((_Port)->Sum = (value))

/*----------------------------------------------------------------------------
  Root methods.
----------------------------------------------------------------------------*/
#define atRootNull ((atRoot)(NULL))
extern atRoot atRootAlloc(void);
#define _atRootNextFree(Root) (*(atRoot *)(void *)(Root))
extern void atRootFree(atRoot Root);
#define atRootGetDestructorHook() (atRootDestructorHook)
#define atRootSetDestructorHook(func) (atRootDestructorHook = (func))
extern void atRootDestroy(atRoot Root);
extern void atRootInsertDevice(atRoot Root, atDevice _Device);
extern void atRootRemoveDevice(atRoot Root, atDevice _Device);
extern void atRootAppendDevice(atRoot Root, atDevice _Device);
#define atRootFindDevice(Root, name) (atDevice)utqEntryHtblSym(&(Root)->Devices, name)
#define atRootGetnumDevices(Root) ((Root)->Devices.count)
#define atRootGetDevices(Root) (&(Root)->Devices)
#define atRootGetfirstDevice(Root) ((atDevice)(utfHtblEntry(atRootGetDevices(Root))))
#define atRootGetlastDevice(Root) ((atDevice)(utlHtblEntry(atRootGetDevices(Root))))
#define atForeachRootDevice(Root, _Device) for(_Device = atRootGetfirstDevice(Root); \
_Device != atDeviceNull; _Device = atDeviceGetnextRootDevice(_Device))
#define atEndForeachRootDevice
#define atSafeForeachRootDevice(Root, _Device) {\
    atDevice _nextDevice;\
    for(_Device = atRootGetfirstDevice(Root); \
        _Device != atDeviceNull; _Device = _nextDevice) {\
        _nextDevice = atDeviceGetnextRootDevice(_Device);
#define atEndSafeForeachRootDevice }}

/*----------------------------------------------------------------------------
  Device methods.
----------------------------------------------------------------------------*/
#define atDeviceNull ((atDevice)(NULL))
extern atDevice atDeviceAlloc(void);
#define _atDeviceNextFree(Device) (*(atDevice *)(void *)(Device))
extern void atDeviceFree(atDevice Device);
#define atDeviceGetDestructorHook() (atDeviceDestructorHook)
#define atDeviceSetDestructorHook(func) (atDeviceDestructorHook = (func))
extern void atDeviceDestroy(atDevice Device);
extern void atDeviceInsertPin(atDevice Device, atPin _Pin);
extern void atDeviceRemovePin(atDevice Device, atPin _Pin);
extern void atDeviceAppendPin(atDevice Device, atPin _Pin);
#define atDeviceFindPin(Device, name) (atPin)utqEntryHtblSym(&(Device)->Pins, name)
#define atDeviceGetnumPins(Device) ((Device)->Pins.count)
#define atDeviceGetPins(Device) (&(Device)->Pins)
#define atDeviceGetfirstPin(Device) ((atPin)(utfHtblEntry(atDeviceGetPins(Device))))
#define atDeviceGetlastPin(Device) ((atPin)(utlHtblEntry(atDeviceGetPins(Device))))
#define atForeachDevicePin(Device, _Pin) for(_Pin = atDeviceGetfirstPin(Device); \
_Pin != atPinNull; _Pin = atPinGetnextDevicePin(_Pin))
#define atEndForeachDevicePin
#define atSafeForeachDevicePin(Device, _Pin) {\
    atPin _nextPin;\
    for(_Pin = atDeviceGetfirstPin(Device); \
        _Pin != atPinNull; _Pin = _nextPin) {\
        _nextPin = atPinGetnextDevicePin(_Pin);
#define atEndSafeForeachDevicePin }}
#define atDeviceGetRoot(_Device) ((_Device)->Root)
#define atDeviceSetRoot(_Device, value) ((_Device)->Root = (value))
#define atDeviceGetSym(Device) ((Device)->h.Sym)
#define atDeviceSetSym(Device, _sym) ((Device)->h.Sym = (_sym))
#define atDeviceGetnextRootDevice(Device) ((atDevice)((Device)->h.nEntry))

/*----------------------------------------------------------------------------
  Pin methods.
----------------------------------------------------------------------------*/
#define atPinNull ((atPin)(NULL))
extern atPin _atPinAlloc(void);
#define _atPinNextFree(Pin) (*(atPin *)(void *)(Pin))
#define atPinAlloc() (_atFirstFreePin == atPinNull? _atPinAlloc() : (\
    _atTempPin = _atFirstFreePin,\
    _atFirstFreePin = _atPinNextFree(_atFirstFreePin),\
    memset((void *)_atTempPin, 0, sizeof(struct _atPin)),\
    _atTempPin))
#define atPinFree(Pin) (_atPinNextFree(Pin) = _atFirstFreePin, _atFirstFreePin = (Pin))
#define atPinGetDestructorHook() (atPinDestructorHook)
#define atPinSetDestructorHook(func) (atPinDestructorHook = (func))
extern void atPinDestroy(atPin Pin);
#define atPinGetDevice(_Pin) ((_Pin)->Device)
#define atPinSetDevice(_Pin, value) ((_Pin)->Device = (value))
#define atPinGetSym(Pin) ((Pin)->h.Sym)
#define atPinSetSym(Pin, _sym) ((Pin)->h.Sym = (_sym))
#define atPinGetnextDevicePin(Pin) ((atPin)((Pin)->h.nEntry))

/*----------------------------------------------------------------------------
  Package level routines.
----------------------------------------------------------------------------*/
extern void atDDRStart(void);
extern void atDDRStop(void);

/*----------------------------------------------------------------------------
  Structure definitions.
----------------------------------------------------------------------------*/
struct _atMport {
    struct _utExtension _extension;
    dbMport _super;
    double CurrentSum;
    double Sum;
};

struct _atContext {
    struct _utHtbl Attrs;
};

struct _atAttr {
    struct _utEntry h;
    double Value;
    atContext Context;
};

struct _atPort {
    struct _utExtension _extension;
    dbPort _super;
    double Sum;
};

struct _atRoot {
    struct _utHtbl Devices;
};

struct _atDevice {
    struct _utEntry h;
    struct _utHtbl Pins;
    atRoot Root;
};

struct _atPin {
    struct _utEntry h;
    atDevice Device;
};

extern struct _utFunctionTable atMportFunctionTable;
extern utSym atMportClassName;
extern atMport _atFirstFreeMport, _atTempMport;
extern void (*atContextDestructorHook)(atContext);
extern atContext _atFirstFreeContext, _atTempContext;
extern void (*atAttrDestructorHook)(atAttr);
extern atAttr _atFirstFreeAttr, _atTempAttr;
extern struct _utFunctionTable atPortFunctionTable;
extern utSym atPortClassName;
extern atPort _atFirstFreePort, _atTempPort;
extern void (*atRootDestructorHook)(atRoot);
extern atRoot _atFirstFreeRoot, _atTempRoot;
extern void (*atDeviceDestructorHook)(atDevice);
extern atDevice _atFirstFreeDevice, _atTempDevice;
extern void (*atPinDestructorHook)(atPin);
extern atPin _atFirstFreePin, _atTempPin;

#endif
